package com.pfc.localiza;

import java.io.IOException;
import java.io.StringReader;
import java.util.ArrayList;
import java.util.List;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import org.apache.http.NameValuePair;
import org.apache.http.message.BasicNameValuePair;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import android.os.AsyncTask;
import android.os.Bundle;
import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.SharedPreferences;
import android.telephony.TelephonyManager;
import android.util.Log;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ScrollView;
import android.widget.TableLayout;
import android.widget.TableRow;
import android.widget.TextView;
import android.widget.Toast;


public class AuthorizedUsersActivity extends Activity {
	
	
	private ProgressDialog pDialog;
	private ProgressDialog pDialog_list;
	
	
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_authorizedusers);
		
		LoadUsersList();
		
		
		final Button btnNew=(Button)findViewById(R.id.btn_new_user);
		final TextView txtNewUsr=(TextView) findViewById(R.id.text_new_user);
		
		
		btnNew.setOnClickListener(new OnClickListener(){

			@Override
			public void onClick(View arg0) {
				
				if (txtNewUsr.getText().toString().equals("")){
					
					Toast toast = Toast.makeText(getApplicationContext(),R.string.nuevo_usuario_vacio, Toast.LENGTH_SHORT);
					toast.show(); 					
				}
				else{
					
					NewUser(txtNewUsr.getText().toString());
					txtNewUsr.setText("");
					
				}
				
			}
			
			
		});
		
		
	}

	

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
	
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}
	
	
	
	
	
	
	//Detectamos si se pulsa el boton de ATRAS o el del menu para finalizar completamente la aplicacin:
	 
	 public boolean onKeyUp(int keyCode, KeyEvent event) {
		    if (keyCode == KeyEvent.KEYCODE_MENU || keyCode == KeyEvent.KEYCODE_HOME) {
		    	finish();
		    	onBackPressed();
		        return true;
		    }
		    else
		    {
		    	return super.onKeyUp(keyCode, event);
		    }
		}
	 
	 @Override
		public void onBackPressed() {
			super.onBackPressed();
			finish();
						
		}
		
		
		 @Override     
		 protected void onPause() {		 

				 super.onPause();
				 finish();
			 
		 }
	
	
	
	
	
	
	/*
	 * Implementamos a continuacin los metodos relacionados con la comunicacin con el servidor. 
	 * De nuevo haremos uso del HttpHandler, pero esta vez a travs de una AsyncTask
	 * 
	 */
	
	private void LoadUsersList() {
		
		pDialog_list = new ProgressDialog(AuthorizedUsersActivity.this, ProgressDialog.STYLE_SPINNER);
		pDialog_list.setMessage(getApplicationContext().getString(R.string.lista_usuarios_Dialog));
		pDialog_list.setCancelable(false);
		final AsyncTask<Void, Void, String> tareaAsincrona;
		tareaAsincrona=new LoadUserListAsync();
		tareaAsincrona.execute();
	
	}

	private void NewUser(String user){
		
		pDialog = new ProgressDialog(AuthorizedUsersActivity.this, ProgressDialog.STYLE_SPINNER);
		pDialog.setMessage(getApplicationContext().getString(R.string.nuevo_usuario_Dialog));
		pDialog.setCancelable(false); 
		final AsyncTask<String, Void, String> tareaAsincrona;
		tareaAsincrona=new NewUserAsync();
		tareaAsincrona.execute(user);
		
	}
	
	private void DeleteUser(String user){
		
		pDialog = new ProgressDialog(AuthorizedUsersActivity.this, ProgressDialog.STYLE_SPINNER);  
		pDialog.setMessage(getApplicationContext().getString(R.string.borrado_usuario_Dialog));    
		pDialog.setCancelable(false);
		final AsyncTask<String, Void, String> tareaAsincrona;
		tareaAsincrona=new DeleteUserAsync();
		tareaAsincrona.execute(user);
		
	}
	
	
	
//Damos de alta una nueva clase privada para realizar el alta de los usuarios.
//Esta clase extiende a AsyncTask, ya que debe realizarse en otro hilo de ejecucin, 
//pero al finalizar deber interactuar con la actividad abierta	 
	 
	private class NewUserAsync extends AsyncTask <String, Void, String>{ 
		  
         protected void onPreExecute() { 
        	 
             pDialog.show(); //Mostramos el dilogo antes de comenzar
             
          } 
   
         protected String doInBackground(String... user) { 
			
			final TelephonyManager tm = (TelephonyManager) getBaseContext().getSystemService(Context.TELEPHONY_SERVICE);
			
			
			ArrayList<NameValuePair> postvalues = new ArrayList<NameValuePair>(4);  
      		postvalues.add(new BasicNameValuePair("imei",tm.getDeviceId()));  
      		postvalues.add(new BasicNameValuePair("user", user[0])); 
      		SharedPreferences prefs = getSharedPreferences("Localiza_preferences",Context.MODE_PRIVATE);
      		postvalues.add(new BasicNameValuePair("deviceid", prefs.getString("deviceid", "")));
      		postvalues.add(new BasicNameValuePair("devicekey",prefs.getString("devicekey", "") ));
      		
      	      		
      		HttpHandler handler = new HttpHandler();  
      		String respuestaPost = handler.post("http://www.localiza-app.com/device/Device_User_Authorization_New_report.php",(ArrayList<NameValuePair>) postvalues);
      		      		
      		return respuestaPost;
      		
          } 
  
         protected void onPostExecute(String result) { 
        	  
        	  pDialog.dismiss(); 
            
              
              if (result.equals("1")){ 
            	  	//Si el servidor devuelve un uno, significa que se ha podido dar de alta el nuevo usuario
            	  	Toast toast = Toast.makeText(getApplicationContext(),R.string.nuevo_usuario_OK, Toast.LENGTH_LONG);
					toast.show(); 
					//Si ha habido exito dando de alta el usuario, actualizamos el la lista de usuarios	
					LoadUsersList();					
              }
              else if (result.equals("2")){
            	  	//Si el servidor devuelve un 2, significa que no existe el usuario indicado
            	  	Toast toast = Toast.makeText(getApplicationContext(),R.string.nuevo_usuario_no_existe, Toast.LENGTH_LONG);
					toast.show(); 	
              }
              
              else if (result.equals("7")){
            	  	//Si el servidor devuelve un 7, significa que el usuario ya estaba autorizado para este terminal
          	  		Toast toast = Toast.makeText(getApplicationContext(),R.string.nuevo_usuario_ya_existe, Toast.LENGTH_LONG);
					toast.show(); 	
            }
              
              
              else{ 
            	  	//Existe algn otro error en el servidor
            	  	Toast toast = Toast.makeText(getApplicationContext(),R.string.nuevo_usuario_error, Toast.LENGTH_LONG);
					toast.show(); 	
              }
              
              
              
          } 
    } 

//Damos de alta otra clase similar a la anterior para la baja de usuarios
	 
	private class DeleteUserAsync extends AsyncTask <String, Void, String>{ 
		  
         protected void onPreExecute() { 
             pDialog.show(); //Mostramos el dilogo antes de comenzar 
             
          } 
                       
         protected String doInBackground( String ... user) {
        	 
        	final TelephonyManager tm = (TelephonyManager) getBaseContext().getSystemService(Context.TELEPHONY_SERVICE);
 		
        	 
 		  	List<NameValuePair> postvalues = new ArrayList<NameValuePair>(4);  
      		postvalues.add(new BasicNameValuePair("imei",tm.getDeviceId()));  
      		postvalues.add(new BasicNameValuePair("user",user[0])); 
      		SharedPreferences prefs = getSharedPreferences("Localiza_preferences",Context.MODE_PRIVATE);
      		postvalues.add(new BasicNameValuePair("deviceid", prefs.getString("deviceid", "")));
      		postvalues.add(new BasicNameValuePair("devicekey",prefs.getString("devicekey", "") ));
      		
      	
      		HttpHandler handler = new HttpHandler();  
      		
      		String respuestaPost = handler.post("http://www.localiza-app.com/device/Device_User_Authorization_Delete_report.php",(ArrayList<NameValuePair>) postvalues);
      		
      		return respuestaPost; 
 		} 
  
         protected void onPostExecute(String result) { 
	              pDialog.dismiss(); 
	              
	              if (result.equals("1")){ 
	            	  	//Si el servidor devuelve un uno, significa que se ha podido eliminar correctamente la autorizacion del usuario
	            	  	Toast toast = Toast.makeText(getApplicationContext(),R.string.borrado_usuario_OK, Toast.LENGTH_LONG);
						toast.show(); 
						//Si ha habido exito dando de alta el usuario, actualizamos el la lista de usuarios					
						LoadUsersList();
						
	              }
	              else if (result.equals("2")){
	            	  	//Si el servidor devuelve un 2, significa que el usuario indicado no tiene acceso a las posiciones del terminal(no es usuario autorizado)
	            	  	Toast toast = Toast.makeText(getApplicationContext(),R.string.borrado_usuario_no_existe, Toast.LENGTH_LONG);
						toast.show(); 	
	              }
	              else{	            	  
	            	  	//Existe algn otro error en el servidor
	            	  	Toast toast = Toast.makeText(getApplicationContext(),R.string.borrado_usuario_error, Toast.LENGTH_LONG);
						toast.show(); 	
	              }
             	  
            	  
            	  
            	  
              }
              
              
        }

		
//Damos de alta otra clase similar a la anterior para cargar la lista de usuarios autorizados
	 

private class LoadUserListAsync extends AsyncTask <Void, Void, String>{ 
	  
    protected void onPreExecute() { 
    	pDialog_list.show(); //Mostramos el dilogo antes de comenzar 
    	EliminarListado();
    } 
                  
    protected String doInBackground( Void ... user) {
   	 
    	final TelephonyManager tm = (TelephonyManager) getBaseContext().getSystemService(Context.TELEPHONY_SERVICE);
    	
	  	List<NameValuePair> postvalues = new ArrayList<NameValuePair>(3);  
 		postvalues.add(new BasicNameValuePair("imei",tm.getDeviceId())); 
  		SharedPreferences prefs = getSharedPreferences("Localiza_preferences",Context.MODE_PRIVATE);
  		postvalues.add(new BasicNameValuePair("deviceid", prefs.getString("deviceid", "")));
  		postvalues.add(new BasicNameValuePair("devicekey",prefs.getString("devicekey", "") ));
  		

 	
 		HttpHandler handler = new HttpHandler();  
 		
 		String respuestaPost = handler.post("http://www.localiza-app.com/device/Device_User_Authorization_List_report.php",(ArrayList<NameValuePair>) postvalues);
 		
 		return respuestaPost; 
	} 

    protected void onPostExecute(String result) { 
             
    		pDialog_list.dismiss(); 
           
             if (result.equals("1")||result.equals("3")||result.equals("4")||result.equals("5"))
             { 
            	 //Si el servidor devuelve uno de los valores anteriores es porque no ha podido montar el xml            
           	  	Toast toast = Toast.makeText(getApplicationContext(),R.string.lista_usuarios_error, Toast.LENGTH_LONG);
				toast.show(); 
				
             }
             else if (result.equals("2"))
             {
            	 //Si el servidor devuelve un 2, significa que no hay usuarios autorizados
           	  	Toast toast = Toast.makeText(getApplicationContext(),R.string.lista_usuarios_vacia, Toast.LENGTH_LONG);
				toast.show(); 
				
             }
             else 
             {            	
            	//Llegados aqui tenemos un xml que debemos procesar:
            	 PintarListado(result);            	           	 
             }      	  
       	  
             
         }
    
    
    
		private void EliminarListado()
		{
			final ScrollView scrollview=(ScrollView) findViewById(R.id.scrollView1);
			scrollview.removeAllViews();
		}
		
		private void PintarListado(String result) 
		{
			//Declaramos las variables que usaremos para pintar la UI
			final ScrollView scrollview=(ScrollView) findViewById(R.id.scrollView1);
			final TableLayout tablelayout=new TableLayout(getApplicationContext());
			TableRow tablerow;
			Button button;
			TextView textview;
			
			scrollview.addView(tablelayout);
			
			
				Document doc = getDomElement(result);
				
			    NodeList Relations = doc.getElementsByTagName("relation");
			    
			    //Recorremos la lista de relations
			    for(int i=0; i<Relations.getLength(); i++) {   			    		
			    		
			    		final Node relation = Relations.item(i);
			    		//Creamos boton:
			    		button=new Button(getApplicationContext());
			    		button.setText(R.string.boton_eliminar);
			    		
			    		button.setTextAppearance(getApplicationContext(),android.R.style.TextAppearance_Small);
			    		button.setTextColor(getResources().getColor(android.R.color.black));
			    		
			    		button.setOnClickListener(new OnClickListener(){

			    			@Override
			    			public void onClick(View arg0) {
			    				DeleteUser(relation.getAttributes().getNamedItem("user").getNodeValue());
			    			}
			    		});
			    			
			    		
			    		//creamos el texto con el nombre del usuario
			    		textview = new TextView(getApplicationContext());
			    		textview.setText(relation.getAttributes().getNamedItem("user").getNodeValue());
			    		
			    		textview.setTextAppearance(getApplicationContext(), android.R.style.TextAppearance_Large);
			    		textview.setTextColor(getResources().getColor(android.R.color.black));
			    		
			    		textview.setPadding(10, 0, 0, 0);
			    		
			    		//Aadimos los dos elementos a la fila, y a la tabla: 
			    		tablerow=new TableRow(getApplicationContext());
			    		tablerow.addView(button);
			    		tablerow.addView(textview);
			    		tablelayout.addView(tablerow);
			        }
			     
		 }
		    
		    
		  //Funcion para leer el xml
		
		    private Document getDomElement(String xml) {
		    	Document doc = null;      
		    	DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();      
		    	try {       
		    		DocumentBuilder db = dbf.newDocumentBuilder();        
		    		InputSource is = new InputSource();        
		    		is.setCharacterStream(new StringReader(xml));      
		    		doc = db.parse(is);              
		    		} 
		    	catch (ParserConfigurationException e) 
		    		{        
		    			Log.e("Error: ", e.getMessage());     
		    			return null;       
		    		}
		    	catch (SAXException e)
		    		{                 
		    		Log.e("Error: ", e.getMessage());    
		    		return null;           
		    		} 
		    	catch (IOException e) 
		    		{             
		    		Log.e("Error: ", e.getMessage());   
		    		return null;     
		    		}               
		     
		    	return doc;   
		    }
		    
		    
         
	}



	
}
	