
package com.pfc.localiza;

import android.os.Bundle;
import android.app.Activity;
import android.content.Context;
import android.content.SharedPreferences;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.Toast;


public class FrecuencyChangeActivity extends Activity {
	
	RadioGroup radioGroup;
	//Tiempos en milisegundos en los que el terminal enviar la localizacin al servidor
	private int[] time_milsec= new int[]{0, 60000, 300000,900000,1800000, 3600000, 18000000,36000000,86400000};
	//Tiempo que el terminal dispone para buscar su localizacin
	private int[] time_loc= new int[]{0, 30000, 120000,300000,600000,600000,600000,600000,600000};


	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_frecuencychange);
		
		radioGroup=(RadioGroup)findViewById(R.id.radiogroup_frec);
		
		LoadPreferences();	
		
		
		//Boton cancelar. No se guardan los cambios
		Button buttonCancel= (Button)findViewById(R.id.buttonCancel);
		buttonCancel.setOnClickListener(new OnClickListener() {     
			  @Override 
			  public void onClick(View v) {  
				   finish();
				   } 
			  }); 
		
		
		//Boton guardar. Si se guardan los cambios SI SON DISTINTOS A LOS EXISTENTES
		final Button buttonSave= (Button)findViewById(R.id.buttonSave);
		buttonSave.setOnClickListener(new OnClickListener() {     
			@Override 
			  public void onClick(View v) { 
			
				
				RadioButton checkedRadioButton = (RadioButton)radioGroup.findViewById(radioGroup.getCheckedRadioButtonId());
			    int checkedIndex = radioGroup.indexOfChild(checkedRadioButton);
			    SharedPreferences prefs = getSharedPreferences("Localiza_preferences",Context.MODE_PRIVATE);
			
				
				if (checkedIndex!=prefs.getInt("frecuency_index", 0)){
					
					SharedPreferences.Editor editor = prefs.edit(); 
					editor.putInt("frecuency_index",checkedIndex);
					editor.putInt("PanicModePrevFrecuencyIndex",checkedIndex);//guardamos este indice como el ultimo activado por el usuario					
					editor.putInt("frecuency_alarm", time_milsec[checkedIndex]);
					editor.putInt("frecuency_location", time_loc[checkedIndex]);
					editor.commit(); 
					
					
					//dado que ha variado la frecuencia de envo, procedemos a 
					//parar las alarmas y a crear las nuevas si la frecuencia no es 0
					
					ReportReceiver reportreceiver = new ReportReceiver();
					
					reportreceiver.cancelAlarm(getApplicationContext());
					
					
					if (prefs.getInt("frecuency_alarm", 0)!=0){
		        		
		        		reportreceiver.setReportReceiver(getBaseContext());
		        		
		        	}
									
				}
		
				
				//Informamos al usuario de que las contraseas se han cambiado con exito
				Toast toast = Toast.makeText(getApplicationContext(),R.string.cambio_frec_OK, Toast.LENGTH_LONG);
				toast.show(); 
						
				//a continuacin cerramos esta activity
				finish();			
				
			}
		});
						
	
		}
	

	
	private void LoadPreferences(){
		
		SharedPreferences prefs = getSharedPreferences("Localiza_preferences",Context.MODE_PRIVATE);
		RadioButton savedCheckedRadioButton = (RadioButton)radioGroup.getChildAt(prefs.getInt("frecuency_index", 0));
		savedCheckedRadioButton.setChecked(true);

		
	}
	
	
	
	
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {		
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}
	

	
	
	 @Override     
	 protected void onPause() {
		 	 
	 	//Si la frecuencia es distinta a la que tenemos guardada, mostramos un mensaje de que no se han guardado los cambios
	 	SharedPreferences prefs = getSharedPreferences("Localiza_preferences",Context.MODE_PRIVATE);
		RadioButton checkedRadioButton = (RadioButton)radioGroup.findViewById(radioGroup.getCheckedRadioButtonId());
	    int checkedIndex = radioGroup.indexOfChild(checkedRadioButton);
	    
		
		if (checkedIndex!=prefs.getInt("frecuency_index", 0)){
			Toast toast = Toast.makeText(getApplicationContext(),R.string.cambio_frec_No_realizado, Toast.LENGTH_SHORT); 
			toast.show(); 
			}

		super.onPause();
		finish();
		 
	 }
	
	
	//Detectamos si se pulsa el boton de ATRAS o el del menu para finalizar completamente la aplicacin:
	 
	 public boolean onKeyUp(int keyCode, KeyEvent event) {
		    if (keyCode == KeyEvent.KEYCODE_MENU || keyCode == KeyEvent.KEYCODE_HOME) {
		    	finish();
		    	onBackPressed();
		        return true;
		    }
		    else
		    {
		    	return super.onKeyUp(keyCode, event);
		    }
		}
	 
	 @Override
		public void onBackPressed() {
			super.onBackPressed();
			finish();
						
		}
			
			
			
	
}
	