package com.pfc.localiza;

import java.io.IOException;
import java.io.StringReader;
import java.util.ArrayList;
import java.util.List;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.apache.http.NameValuePair;
import org.apache.http.message.BasicNameValuePair;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.AsyncTask;
import android.os.Bundle;
import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.telephony.TelephonyManager;
import android.util.Log;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.TextView;
import android.widget.Toast;


public class MainActivity extends Activity {
	
	private ProgressDialog pDialog;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
				
		SharedPreferences prefs = getSharedPreferences("Localiza_preferences",Context.MODE_PRIVATE);
		if (!prefs.getBoolean("OpenMainActivity", false))
		{
			onBackPressed();
		}
		
		
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		
		TextView cambio_frecuencia =(TextView)findViewById(R.id.envio_posicion_main);
		TextView usuarios_autorizados =(TextView)findViewById(R.id.usuarios_autorizados_main);
		TextView cambio_pwd =(TextView)findViewById(R.id.cambio_pwd_main);
		TextView modo_seguro=(TextView)findViewById(R.id.securemode_main);
		
		
		cambio_frecuencia.setOnClickListener(new OnClickListener(){
			  @Override 
			  public void onClick(View v) {  
				  
				  Intent i1=new Intent(getApplicationContext(),FrecuencyChangeActivity.class);				  
				  startActivity(i1);	  
				   } 
			  });
		
		usuarios_autorizados.setOnClickListener(new OnClickListener(){
			  @Override 
			  public void onClick(View v) {  
				  
					  if (isNetworkAvailable()){
					  	  Intent i1=new Intent(getApplicationContext(),AuthorizedUsersActivity.class);				  
					  	  startActivity(i1);
					  }
					  else{
						  Toast toast = Toast.makeText(getApplicationContext(),R.string.cambio_pwd_No_internet, Toast.LENGTH_LONG);
						  toast.show();
					  }
						  
				   } 
			  });
		
		cambio_pwd.setOnClickListener(new OnClickListener(){
			  @Override 
			  public void onClick(View v) {  
				  
				  Intent i1=new Intent(getApplicationContext(),PwdChangeActivity.class);				  
				  startActivity(i1);	  
				   } 
			  });
		
		
		modo_seguro.setOnClickListener(new OnClickListener(){
			  @Override 
			  public void onClick(View v) {  
				  
				  Intent i1=new Intent(getApplicationContext(),SecureModeActivity.class);				  
				  startActivity(i1);	  
				   } 
			  });
				
		checkFirstConnection();
			
	}
	
	
	

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

	
	
	
	
	//Cuando salimos de la pantalla, bien porque  se abre otra aplicacion o porque se pulsa el boton de "ATRAS", finalizamos
	//la actividad, de forma que solo sea posible volver a acceder a ella introduciendo la clave correcta
		
	@Override
	public void onBackPressed() {
		
		SharedPreferences prefs = getSharedPreferences("Localiza_preferences",Context.MODE_PRIVATE);
		SharedPreferences.Editor editor = prefs.edit(); 
		editor.putBoolean("OpenMainActivity",false);
		editor.commit(); 
	
		
		super.onBackPressed();
		onPause();
		finish();
		android.os.Process.killProcess(android.os.Process.myPid());

	
	}
	
	
	 public boolean onKeyUp(int keyCode, KeyEvent event) {
		    if (keyCode == KeyEvent.KEYCODE_MENU || keyCode == KeyEvent.KEYCODE_HOME) {
		    	onBackPressed();
		        return true;
		    }
		    else
		    {
		    	return super.onKeyUp(keyCode, event);
		    }
		}
	 
	 
	 @Override     
	 protected void onPause() {
		 super.onPause();
		 super.onStop();
		 super.onDestroy();
			
	 }

	
	 private boolean isNetworkAvailable() {
		    getApplicationContext();
			ConnectivityManager connectivityManager = (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
		    NetworkInfo activeNetworkInfo = connectivityManager.getActiveNetworkInfo();
		    return activeNetworkInfo != null && activeNetworkInfo.isConnected();
		}
	  
	 
	 public void checkFirstConnection(){
		 
		 //Cuando el terminal inicia por primera vez la aplicacin, debemos darlo de alta en la web
		 //En este paso le asignamos una clave unica que le permitir registrar localizaciones, y usuarios autorizados:
		 
		 SharedPreferences prefs = getSharedPreferences("Localiza_preferences",Context.MODE_PRIVATE);
		 
		 if (prefs.getString("deviceid", "").equals("") || prefs.getString("devicekey", "").equals(""))
		 {
			 
			 //Si no estn definidas estas dos preferencias es porque se trata de la primera conexin del terminal
			 //En este caso debemos comprobar que disponemos de conexin a internet, pues de lo contrario no podramos 
			 //obtener la informacin del servidor
			 
			 if (!isNetworkAvailable())
			 {
				Toast toast = Toast.makeText(getApplicationContext(),R.string.networkNotAvailable_Main, Toast.LENGTH_LONG);
				toast.show(); 	
				finish(); //Salimos de la aplicacin
			 }
			 else
			 {
				 
				pDialog = new ProgressDialog(MainActivity.this, ProgressDialog.STYLE_SPINNER);
				pDialog.setMessage(getApplicationContext().getString(R.string.alta_terminal_main_Dialog));
				pDialog.setCancelable(false); 
				final AsyncTask<Void, Void, String> tareaAsincrona;
				tareaAsincrona=new NewDeviceAsync();
				tareaAsincrona.execute();
				 
			 }
		 }
	 }
	 
	 

private class NewDeviceAsync extends AsyncTask <Void, Void, String>{ 
	  
    protected void onPreExecute() { 
    	pDialog.show(); //Mostramos el dilogo antes de comenzar 
    } 
                  
    protected String doInBackground( Void ... user) {
   	 
    	final TelephonyManager tm = (TelephonyManager) getBaseContext().getSystemService(Context.TELEPHONY_SERVICE);
    	
	  	List<NameValuePair> postvalues = new ArrayList<NameValuePair>(1);  
 		postvalues.add(new BasicNameValuePair("imei",tm.getDeviceId()));  

 	
 		HttpHandler handler = new HttpHandler();  
 		
 		String respuestaPost = handler.post("http://www.localiza-app.com/device/Device_Autorization_Key.php",(ArrayList<NameValuePair>) postvalues);  
 	
 		return respuestaPost; 
	} 

    protected void onPostExecute(String result) { 
             
    		pDialog.dismiss(); 
 
             
             if (result.equals("1"))
             { 
            	//Si el servidor devuelve uno de los valores anteriores es porque no ha podido montar el xml
              	Toast toast = Toast.makeText(getApplicationContext(),R.string.alta_terminal_main_Error, Toast.LENGTH_LONG);
				toast.show(); 
				finish();//como no ha sido posible dar de alta el terminal, salimos de la aplicacin
				
             }
            else 
             {
            	//Llegados aqui tenemos un xml que debemos procesar:
            	Document doc = getDomElement(result);
            	NodeList Authorizations = doc.getElementsByTagName("authorization");
            	if (Authorizations.getLength()==1)
            	{
	            	final Node authorization = Authorizations.item(0);
	            	SharedPreferences prefs = getSharedPreferences("Localiza_preferences",Context.MODE_PRIVATE);
	       		 	SharedPreferences.Editor editor = prefs.edit(); 
					editor.putString("deviceid",authorization.getAttributes().getNamedItem("deviceid").getNodeValue());
					editor.putString("devicekey", authorization.getAttributes().getNamedItem("devicekey").getNodeValue() );
					editor.commit(); 
					
            	}
            	else
            	{
            		//si no hay ningn elemento es que ha habido algn error de comunicacin
            		Toast toast = Toast.makeText(getApplicationContext(),R.string.alta_terminal_main_Error, Toast.LENGTH_LONG);
    				toast.show(); 
    				finish();// salimos de la aplicacin
            	}
            	}
            	           	 
             }      	  
       	  
    
    
             
         }

    
//Funcion para leer el xml

private Document getDomElement(String xml) {
	Document doc = null;      
	DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();      
	try {       
		DocumentBuilder db = dbf.newDocumentBuilder();        
		InputSource is = new InputSource();        
		is.setCharacterStream(new StringReader(xml));      
		doc = db.parse(is);              
		} 
	catch (ParserConfigurationException e) 
		{        
			Log.e("Error: ", e.getMessage());     
			return null;       
		}
	catch (SAXException e)
		{                 
		Log.e("Error: ", e.getMessage());    
		return null;           
		} 
	catch (IOException e) 
		{             
		Log.e("Error: ", e.getMessage());   
		return null;     
		}               
	// return DOM     
	return doc;   
}

	 
	 
	 
}
