package com.pfc.localiza;


import java.util.Timer;
import java.util.TimerTask;
import android.content.Context;
import android.content.SharedPreferences;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.util.Log;

public class MyLocation {
	
    Timer timer1;
    LocationManager lm;
    LocationResult locationResult;
    public Location RealGpsLoc,RealNetworkLoc,CurrentLocation;
    boolean gps_enabled=false;
    boolean network_enabled=false;
    String locationSource="";

    LocationListener locationListenerGps = new LocationListener() {
        public void onLocationChanged(Location location) {
           
        	RealGpsLoc=new Location(location);        	
        	//Log.d("MyLocation","Dentro de locationlistenerGps. Obteniendo posicion real: RealGpsLoc.lat="+RealGpsLoc.getLatitude());
        	
        }
        public void onProviderDisabled(String provider) {}
        public void onProviderEnabled(String provider) {}
        public void onStatusChanged(String provider, int status, Bundle extras) {}
    };
    
       
    LocationListener locationListenerNetwork = new LocationListener() {
        public void onLocationChanged(Location location) {
            
        	RealNetworkLoc=new Location(location);
        	//Log.d("MyLocation","Dentro de locationlistenerNetwork. Obteniendo posicion real: RealNetworkLoc.lat="+RealNetworkLoc.getLatitude());
        	
        }
        public void onProviderDisabled(String provider) {}
        public void onProviderEnabled(String provider) {}
        public void onStatusChanged(String provider, int status, Bundle extras) {}
                
    };

    
    
    public boolean getLocation(Context context, LocationResult result)
    {
    	
    	SharedPreferences prefs = context.getSharedPreferences("Localiza_preferences",Context.MODE_PRIVATE);
        locationResult=result;
        
        if(lm==null){
            lm = (LocationManager) context.getSystemService(Context.LOCATION_SERVICE);
        }	
        
        try{gps_enabled=lm.isProviderEnabled(LocationManager.GPS_PROVIDER);}catch(Exception ex){}
        try{network_enabled=lm.isProviderEnabled(LocationManager.NETWORK_PROVIDER);}catch(Exception ex){}

       if(!gps_enabled && !network_enabled)
            return false;

        Log.d("ReportService","gps_enabled="+ gps_enabled + ", network_enabled=" + network_enabled);
        
        if(gps_enabled)
            lm.requestLocationUpdates(LocationManager.GPS_PROVIDER, 0, 0, locationListenerGps);
        if(network_enabled)
            lm.requestLocationUpdates(LocationManager.NETWORK_PROVIDER, 0, 0, locationListenerNetwork);
        
       
       timer1=new Timer();
       timer1.schedule(new GetBetterLocation(), prefs.getInt("frecuency_location", 0)); 
    	
        return true;
    }
    
    
    
    class GetBetterLocation extends TimerTask {
        @Override
        public void run() {
        	
               	
        	//cancelamos las actualizaciones del LocationManager lm        	
             lm.removeUpdates(locationListenerGps);
             lm.removeUpdates(locationListenerNetwork);
            
             if (RealGpsLoc!=null)
             {
	            	 CurrentLocation=new Location(RealGpsLoc); //Si hemos obtenido una posicion gps, la tomamos como la actual            	 
	            	 locationSource="GPS_REAL";
             }
             else if (RealNetworkLoc!=null)
             {
	            	 CurrentLocation=new Location(RealNetworkLoc); //Si hemos obtenido una posicion network, la tomamos como la actual     
	            	 locationSource="NETWORK_REAL";
             }
             else   // Si no hemos obtenido ninguna posicion real, recurrimos a los ltimos valores conocidos.
             {	 
	            	 Location LastNetworkLoc=null, LastGpsLoc=null;
	            	 
	            	 if(gps_enabled)
            		 {
            		 	LastGpsLoc=lm.getLastKnownLocation(LocationManager.GPS_PROVIDER);
            		 }
	                 if(network_enabled)
                	 {
                	 	LastNetworkLoc=lm.getLastKnownLocation(LocationManager.NETWORK_PROVIDER);
                	 }
	
	                 //si existen valores para ambas posiciones, utilizamos la mas reciente
	                 if(LastGpsLoc!=null && LastNetworkLoc!=null)
	                 {
	                	 
	                     if(LastGpsLoc.getTime()>LastNetworkLoc.getTime())
	                     {
	                    	 CurrentLocation=new Location(LastGpsLoc);
	                    	 locationSource="GPS_LAST";
	                     }
	                     else
	                     {
	                    	 CurrentLocation=new Location(LastNetworkLoc);
	                    	 locationSource="NETWORK_LAST";
	                     }
	                 }
	                 else if(LastGpsLoc!=null)
	                 {    
	                	 CurrentLocation=new Location(LastGpsLoc); 
	                	 locationSource="GPS_LAST";
	                 }
	                 else if(LastNetworkLoc!=null)
	                 {
	                	 CurrentLocation=new Location(LastNetworkLoc);
	                	 locationSource="NETWORK_LAST";
	                 }
	                 else    
	                 {
	                	// Si no existe ninguna posicion almacenada en ninguno de los proveedores, devolvemos null
	                	 CurrentLocation=null;                	 
	                 }
	                 
             }
             
             //ya tenemos la posicin actual, por lo que ejecutamos la funcion gotLocation de ReportService            
             
             locationResult.gotLocation(CurrentLocation,locationSource);  
             return;
             
        }
    }

    public static abstract class LocationResult{
        public abstract void gotLocation(Location location,String locationSource);
    }
}