package com.pfc.localiza;

import android.os.Bundle;
import android.app.Activity;
import android.content.Context;
import android.content.SharedPreferences;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;


public class PwdChangeActivity extends Activity {	
	
	public Boolean pwd_changed=false;
	
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_pwdchange);
		
		
		final TextView pwdPrev = (TextView)findViewById(R.id.editTextpwdprev);
		final TextView pwdNew = (TextView)findViewById(R.id.editTextpwd1);
		
		
		
		//Boton cancelar. No se guardan los cambios
		Button buttonCancel= (Button)findViewById(R.id.buttonCancel);
		buttonCancel.setOnClickListener(new OnClickListener() {     
			  @Override 
			  public void onClick(View v) {  
				   finish();
				   } 
			  }); 
		
		
		//Boton guardar. Si se guardan los cambios SI SON CORECTOS
		final Button buttonSave= (Button)findViewById(R.id.buttonSave);		
		
		buttonSave.setOnClickListener(new OnClickListener() {     
			@Override 
			  public void onClick(View v) { 
				
				
				if (IsPasswordOk (pwdPrev.getText().toString(),pwdNew.getText().toString())){
					
					//Si los valores de las contraseas son los adecuados procedemos a actualizar la contrasea del usuario
					SharedPreferences prefs = getSharedPreferences("Localiza_preferences",Context.MODE_PRIVATE);
					SharedPreferences.Editor editor = prefs.edit(); 
					editor.putString("pwd_pref",pwdNew.getText().toString());
					editor.commit(); 
					
					//Informamos al usuario de que las contraseas se han cambiado con exito
					Toast toast = Toast.makeText(getApplicationContext(),R.string.cambio_pwd_OK, Toast.LENGTH_LONG);
					toast.show(); 
					pwd_changed=true;
					
					//a continuacin cerramos esta activity
					finish();					
				}
				else{
					
					//Si la contrasea no es correcta borramos el contenido de los EditText. 
					//Ya se han mostrado los correspondientes mensajes de error en la funcion IsPasswordOK					
					
					pwdPrev.setText(null);
					pwdNew.setText(null);
										
					
				}
				
			}
		});
		
		
		
		
		
	}
	
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}
	
	
	public boolean IsPasswordOk (String pwdPrev,String pwdNew)
	{
		

		if (pwdPrev.equals("") || pwdNew.equals("")) {
			Toast toast = Toast.makeText(getApplicationContext(),R.string.cambio_pwd_KO_blanco, Toast.LENGTH_LONG); 
			toast.show(); 			
			return false;
		}

		
		if (pwdNew.length()<4){
			Toast toast = Toast.makeText(getApplicationContext(),R.string.cambio_pwd_KO_corta, Toast.LENGTH_LONG); 
			toast.show(); 			
			return false;
		}
		
		final SharedPreferences prefs = getSharedPreferences("Localiza_preferences",Context.MODE_PRIVATE);
		
		if(!pwdPrev.equals(prefs.getString("pwd_pref", "0000"))){
			Toast toast = Toast.makeText(getApplicationContext(),R.string.cambio_pwd_KO_general, Toast.LENGTH_LONG); 
			toast.show(); 			
			return false;
		}
		
		return true;
	
	}
	
	//Detectamos si se pulsa el boton de ATRAS o el del menu para finalizar completamente la aplicacin:
	
	 @Override     
	 protected void onPause() {
				 
		 if (!pwd_changed){
			 Toast toast = Toast.makeText(getApplicationContext(),R.string.cambio_pwd_No_realizado, Toast.LENGTH_LONG); 
			 toast.show(); 
		 }
		 super.onPause();
		 finish();
		 
	 }
	
		 
	 public boolean onKeyUp(int keyCode, KeyEvent event) {
		    if (keyCode == KeyEvent.KEYCODE_MENU || keyCode == KeyEvent.KEYCODE_HOME) {
		    	finish();
		    	onBackPressed();
		        return true;
		    }
		    else
		    {
		    	return super.onKeyUp(keyCode, event);
		    }
		}
	 
	 @Override
		public void onBackPressed() {
			super.onBackPressed();
			finish();
						
		}
		

}
	