

/*
 * 
 * Con este receiver implementamos una alarma que ejecutar cada cierto tiempo 
 * el servicio ReportService.
 * 
 * La alarma queda a la espera de que termine el servicio antes de finalizar.
 * 
 * Adems, por las propiedades de la alarma (ELAPSED_REALTIME_WAKEUP)se ejecuta incluso cuando el 
 * terminal est en espera.
 * 
 */



package com.pfc.localiza;

import android.app.AlarmManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.support.v4.content.WakefulBroadcastReceiver;


public class ReportReceiver extends WakefulBroadcastReceiver {
		
	private AlarmManager alarmMgr;
	private PendingIntent alarmIntent;
  
    @Override
    public void onReceive(Context context, Intent intent) {   

        Intent reportservice = new Intent(context, ReportService.class); 
        startWakefulService(context, reportservice);
             
    }


    public void setReportReceiver(Context context) {
    	
    	SharedPreferences prefs = context.getSharedPreferences("Localiza_preferences",Context.MODE_PRIVATE);
    	
    	
    	alarmMgr = (AlarmManager)context.getSystemService(Context.ALARM_SERVICE);
        Intent intent = new Intent(context, ReportReceiver.class);
        alarmIntent = PendingIntent.getBroadcast(context, 0, intent, 0);
        
        
        //Establecemos la periodicidad de la alarma segn las preferencias del usuario
       
        alarmMgr.setInexactRepeating(AlarmManager.ELAPSED_REALTIME_WAKEUP, 
        		 0,
                 prefs.getInt("frecuency_alarm", 900000),
                 alarmIntent);
        
    }


    public void cancelAlarm(Context context) {
    	
     
    	// Verificamos si existe alarmMgr. en caso contrario lo creamos, 
    	//pues es necesario para proceder a cancelar las alarmas de sesiones anteriores
    	
		if (alarmMgr== null) {
	    	alarmMgr = (AlarmManager)context.getSystemService(Context.ALARM_SERVICE);
		}
		
		Intent intent = new Intent(context, ReportReceiver.class);
		alarmIntent = PendingIntent.getBroadcast(context, 0, intent, 0);
	
		try
		{
			alarmMgr.cancel(alarmIntent);			
		} 
		catch (Exception e) {}   		
       
    }
    
}
