package com.pfc.localiza;

import android.app.Activity;
import android.content.Context;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.TextView;
import android.widget.Toast;


public class SecureModeActivity extends Activity {	
	
	CheckBox securemode;
	TextView phone1;
	TextView phone2;
	TextView phone3;
	
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_securemode);
		
		securemode=(CheckBox)findViewById(R.id.SecureModeCheckBox);
		phone1=(TextView)findViewById(R.id.editTextphone1);
		phone2=(TextView)findViewById(R.id.editTextphone2);
		phone3=(TextView)findViewById(R.id.editTextphone3);
		
		
		LoadPreferences();	
		
		//Boton cancelar. No se guardan los cambios
		Button buttonCancel= (Button)findViewById(R.id.buttonCancel);
		buttonCancel.setOnClickListener(new OnClickListener() {     
			  @Override 
			  public void onClick(View v) {  
				  
				//Informamos al usuario de que no se guardaran los cambios
					Toast toast = Toast.makeText(getApplicationContext(),R.string.cambio_telefonos_No_realizado, Toast.LENGTH_LONG);
					toast.show(); 
							
					//a continuacin cerramos esta activity
					finish();		
				   } 
			  }); 
		
		final Button buttonSave= (Button)findViewById(R.id.buttonSave);
		
		buttonSave.setOnClickListener(new OnClickListener() {     
			@Override 
			  public void onClick(View v) { 
				
				Boolean val_phones= true;
				
				
				if (((!phone1.getText().toString().equals("")) && (phone1.length()!=9))|| ((!phone2.getText().toString().equals("")) && (phone2.length()!=9))||((!phone3.getText().toString().equals("")) && (phone3.length()!=9)))
					{
						val_phones=false;
					}
					
				if (val_phones)
					{
					    SharedPreferences prefs = getSharedPreferences("Localiza_preferences",Context.MODE_PRIVATE);
					
						SharedPreferences.Editor editor = prefs.edit(); 
						editor.putBoolean("SecureModeOn",securemode.isChecked());
						editor.putString("AuthorizedSmsSource1",phone1.getText().toString());				
						editor.putString("AuthorizedSmsSource2",phone2.getText().toString());
						editor.putString("AuthorizedSmsSource3",phone3.getText().toString());
						editor.commit(); 
							
						
						//Informamos al usuario de que los telfonos se han guardado
						Toast toast = Toast.makeText(getApplicationContext(),R.string.cambio_telefonos_OK, Toast.LENGTH_LONG);
						toast.show(); 
								
						//a continuacin cerramos esta activity
						finish();
					}
				else
					{
					//Informamos al usuario de que alguno de los telefonos informados no es vlido
					Toast toast = Toast.makeText(getApplicationContext(),R.string.cambio_telefonos_error, Toast.LENGTH_LONG);
					toast.show(); 
					
					}
				}
						
			
		});
		
		
	}
		
		@Override
		public boolean onCreateOptionsMenu(Menu menu) {
			getMenuInflater().inflate(R.menu.main, menu);
			return true;
		}
		

		
		 private void LoadPreferences(){
				
				SharedPreferences prefs = getSharedPreferences("Localiza_preferences",Context.MODE_PRIVATE);
				if (prefs.getBoolean("SecureModeOn", false))
					{
						securemode.setChecked(true);
					}
				if (!prefs.getString("AuthorizedSmsSource1","").equals(""))
					{
						phone1.setText((CharSequence)prefs.getString("AuthorizedSmsSource1",""));
					}
				if (!prefs.getString("AuthorizedSmsSource2","").equals(""))
					{
						phone2.setText((CharSequence)prefs.getString("AuthorizedSmsSource2",""));
					}
				if (!prefs.getString("AuthorizedSmsSource3","").equals(""))
					{
						phone3.setText((CharSequence)prefs.getString("AuthorizedSmsSource3",""));
					}
				
			}
		 
		 
		//Detectamos si se pulsa el boton de ATRAS o el del menu para finalizar completamente la aplicacin:
		 
		 public boolean onKeyUp(int keyCode, KeyEvent event) {
			    if (keyCode == KeyEvent.KEYCODE_MENU || keyCode == KeyEvent.KEYCODE_HOME) {
			    	finish();
			    	onBackPressed();
			        return true;
			    }
			    else
			    {
			    	return super.onKeyUp(keyCode, event);
			    }
			}
		 
		 
		
		
		 @Override
			public void onBackPressed() {
				super.onBackPressed();
				finish();
				
				
			}
			
		 	
			 @Override     
			 protected void onPause() {		
				 	super.onPause();
					finish();
				 
			 }
			
			
	}
	
	
	
	