package com.pfc.localiza;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.telephony.SmsMessage;
import android.widget.Toast;



public class SmsReceiver extends BroadcastReceiver {
	
	
	//Tiempos en milisegundos en los que el terminal enviar la localizacin al servidor
	private int[] time_milsec= new int[]{0, 60000, 300000,900000,1800000, 3600000, 18000000,36000000,86400000};
	//Tiempo que el terminal dispone para buscar su localizacin
	private int[] time_loc= new int[]{0, 30000, 120000,300000,600000,600000,600000,600000,600000};


	public void onReceive(Context context, Intent intent) { 
		
		
   
        if(intent.getAction().equals("android.provider.Telephony.SMS_RECEIVED")) {
        	
              Bundle extras = intent.getExtras();
                if ( extras != null )
                {
                    Object[] smsextras = (Object[]) extras.get( "pdus" );
                    for ( int i = 0; i < smsextras.length; i++ )
                    {
                        SmsMessage smsmsg = SmsMessage.createFromPdu((byte[])smsextras[i]);

                        String MsgBody = mayusculas(smsmsg.getMessageBody().toString());
                        String MsgSrc = smsmsg.getOriginatingAddress();
                        
                       
                        Toast toast = Toast.makeText(context,MsgSrc, Toast.LENGTH_LONG); 
                        toast.show();
                        
                        SharedPreferences prefs = context.getSharedPreferences("Localiza_preferences",Context.MODE_PRIVATE);
                        
                        //Analizamos si se trata de alguno de los numeros autorizados
                        if ((!prefs.getString("AuthorizedSmsSource1", "").equals("") && MsgSrc.contains(prefs.getString("AuthorizedSmsSource1", "")))||
                        	(!prefs.getString("AuthorizedSmsSource2", "").equals("") && MsgSrc.contains(prefs.getString("AuthorizedSmsSource2", "")))||
                        	(!prefs.getString("AuthorizedSmsSource3", "").equals("") && MsgSrc.contains(prefs.getString("AuthorizedSmsSource3", ""))))
                        {
                     
                        	if (MsgBody.equals("LOCALIZA START"))
                        	{
                        		int Prev_frecuency= prefs.getInt("frecuency_index", 0);
                        		
                        		//Activamos la opcin de localizacin ms frecuente (1 minuto) y activamos el PanicMode para que no se puedan ejecutar llamadas
                        		SharedPreferences.Editor editor = prefs.edit();
            					editor.putBoolean("SecureModeOn",true);
            					editor.putInt("frecuency_index",1);
            					editor.putInt("SecureModePrevFrecuencyIndex",Prev_frecuency);
            					editor.putInt("frecuency_alarm", 60000);
            					editor.putInt("frecuency_location", 30000);
            					editor.commit(); 
            					
            					ReportReceiver reportreceiver = new ReportReceiver();            					
            					reportreceiver.cancelAlarm(context);
            					reportreceiver.setReportReceiver(context);
            					
            					
                        		abortBroadcast();//Cancelamos el SMS para que no pueda visualizarse
                        	}
                        	else if (MsgBody.equals("LOCALIZA STOP"))
                        	{
                        		//Volvemos a aplicar los valores de antes de activarse PanicMode
                        		
                        		int Prev_frecuency= prefs.getInt("PanicModePrevFrecuencyIndex", 0);
                        		SharedPreferences.Editor editor = prefs.edit();
            					editor.putBoolean("SecureModeOn",false);
            					editor.putInt("frecuency_index",Prev_frecuency);
            					editor.putInt("frecuency_alarm", time_milsec[Prev_frecuency]);
            					editor.putInt("frecuency_location", time_loc[Prev_frecuency]);
            					editor.commit(); 
                        		
            					//dado que ha variado la frecuencia de envo, procedemos a 
            					//parar las alarmas y a crear las nuevas si la frecuencia no es 0
            					
            					ReportReceiver reportreceiver = new ReportReceiver();
            					
            					reportreceiver.cancelAlarm(context);
            					if (prefs.getInt("frecuency_alarm", 0)!=0)
            					{
            		        		reportreceiver.setReportReceiver(context);            		        		
            		        	}
                        		abortBroadcast();//Cancelamos el SMS para que no pueda visualizarse
                        	}                        	
                        }                       
                    }
                }
        	}
		}
	
	
	String mayusculas(String source){
        
        char[]  out = source.toCharArray();
        int i, len = source.length();
        for(i=0; i<len; i++){
                out[i] = Character.toUpperCase(out[i]);
            }
        return new String(out);
    }
	
}











